CREATE TABLE Periodico(
	nombre_periodico CHAR(255),
	tipo_informacion CHAR(255),
	link CHAR(255),
	uso BOOLEAN,
	PRIMARY KEY (nombre_periodico,tipo_informacion)
)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
CREATE TABLE Titulares(
	titulo CHAR(255),
	titulo_limpio CHAR(255),
	fecha DATETIME,
	palabras int,
	caracteres int,
	nombre_periodico CHAR(100),
	tipo_informacion CHAR(100),
	num int,
	PRIMARY KEY (num),
	FOREIGN KEY (nombre_periodico,tipo_informacion) 
    REFERENCES Periodico(nombre_periodico,tipo_informacion)
)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
CREATE TABLE Palabras(
	palabra CHAR(255),
	nombre_periodico CHAR(255),
	tipo_informacion CHAR(255),
	contador int,
	num int,
	negativa BOOLEAN,
	busqueda BOOLEAN,
	PRIMARY KEY (palabra,nombre_periodico,tipo_informacion,num),
	FOREIGN KEY (nombre_periodico,tipo_informacion) 
    REFERENCES Periodico(nombre_periodico,tipo_informacion),
	FOREIGN KEY (num) REFERENCES Titulares (num)
)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
CREATE TABLE Negativas(
	palabra CHAR(255),
	PRIMARY KEY (palabra),
	FOREIGN KEY (palabra) REFERENCES Palabras(palabra)
)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;
CREATE TABLE Busqueda(
	palabra CHAR(255),
	PRIMARY KEY (palabra),
	FOREIGN KEY (palabra) REFERENCES Palabras(palabra)
)ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;

INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'El Pais', 'Último','http://ep00.epimg.net/rss/tags/ultimas_noticias.xml',false );
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'El Pais', 'Opinión','http://ep00.epimg.net/rss/elpais/opinion.xml' ,false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso )
VALUES ( 'El Pais', 'Economía','http://ep00.epimg.net/rss/economia/portada.xml',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'El Pais', 'Cultura', 'http://ep00.epimg.net/rss/cultura/portada.xml',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'El Pais', 'Deportes', 'http://ep00.epimg.net/rss/deportes/portada.xml',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'ABC', 'Último', 'https://www.abc.es/rss/feeds/abc_ultima.xml',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'ABC', 'Opinión','https://www.abc.es/rss/feeds/abc_opinioncompleto.xml' ,false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'ABC', 'Economía', 'https://www.abc.es/rss/feeds/abc_Economia.xml',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'ABC', 'Cultura','https://www.abc.es/rss/feeds/abc_Cultura.xml' ,false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'ABC', 'Deportes', 'https://www.abc.es/rss/feeds/abc_Deportes.xml',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'La Vanguardia', 'Último', 'https://www.lavanguardia.com/mvc/feed/rss/home',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'La Vanguardia', 'Opinión', 'https://www.lavanguardia.com/mvc/feed/rss/opinion',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'La Vanguardia', 'Economía', 'https://www.lavanguardia.com/mvc/feed/rss/economia',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'La Vanguardia', 'Cultura', 'https://www.lavanguardia.com/mvc/feed/rss/cultura',false);
INSERT INTO Periodico ( nombre_periodico, tipo_informacion, link ,uso ) 
VALUES ( 'La Vanguardia', 'Deportes', 'https://www.lavanguardia.com/mvc/feed/rss/deportes',false);






