package Controlador;

import Modelo.Periodico;
import Modelo.UsoBD;
import Vista.Results;
import Vista.StartWindow;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;

/**
 * Clase controlador de la vista StartWindow.
 * @author Adrián
 */
public class control_StartWindow implements ActionListener{
    private Periodico period;
    private UsoBD mod; 
    private StartWindow miVista;

    /**
     * Constructor de la clase.
     * Se añaden los listener de los objetos de la vista para que muestren los eventos del usuario en la interfaz.
     * @param period Instancia para obtener la infromación de los Periódicos.
     * @param mod Instancia para interactuar con la base de datos.
     * @param miVista Vista StartWindow correspondiente.
     */
    public control_StartWindow( Periodico period, UsoBD mod,StartWindow miVista){
           this.period = period;
           this.mod=mod;
           this.miVista=miVista;
           this.miVista.ABC.addActionListener(this);
           this.miVista.La_Vanguardia.addActionListener(this);
           this.miVista.Cultura.addActionListener(this);
           this.miVista.Deportes.addActionListener(this);
           this.miVista.La_Vanguardia.addActionListener(this);
           this.miVista.Economia.addActionListener(this);
           this.miVista.El_Pais.addActionListener(this);
           this.miVista.Opinion.addActionListener(this);
           this.miVista.Inicio.addActionListener(this);
           this.miVista.Ultimo.addActionListener(this);
           this.miVista.Valor.addActionListener(this);
           this.miVista.Horas.addActionListener(this);
           this.miVista.Titulares.addActionListener(this);
           this.miVista.Todos.addActionListener(this);
           this.miVista.Eliminar.addActionListener(this);
    }
    /**
     * Acción correspondiente a realizar, dependiendo del evento en la vista StartWindow.
     * @param e 
     */
    public void actionPerformed(ActionEvent e) {
        //Si el usuario pulsa en "Seleccioanar todos", todos los CheckBoxes se seleccionan.
        //Se activan los CheckBoxes de tipo de información, que podrían estar desactivados.
        if (e.getSource() == miVista.Todos) {
            miVista.Ultimo.setSelected(true);
            miVista.Opinion.setSelected(true);
            miVista.Economia.setSelected(true);
            miVista.Cultura.setSelected(true);
            miVista.Deportes.setSelected(true);
            miVista.Ultimo.setEnabled(true);
            miVista.Opinion.setEnabled(true);
            miVista.Economia.setEnabled(true);
            miVista.Cultura.setEnabled(true);
            miVista.Deportes.setEnabled(true);
            miVista.El_Pais.setSelected(true);
            miVista.La_Vanguardia.setSelected(true);
            miVista.ABC.setSelected(true);
            miVista.Eliminar.setEnabled(true);
        }
        //Si el usuario pulsa en "Eliminar selecciones", todos los CheckBoxes se deseleccionan.
        //Se desactivan los CheckBoxes de tipo de información, que se encontraban activados.
        if (e.getSource() == miVista.Eliminar) {
            miVista.Ultimo.setSelected(false);
            miVista.Opinion.setSelected(false);
            miVista.Economia.setSelected(false);
            miVista.Cultura.setSelected(false);
            miVista.Deportes.setSelected(false);
            miVista.ABC.setSelected(false);
            miVista.El_Pais.setSelected(false);
            miVista.La_Vanguardia.setSelected(false);
            miVista.Ultimo.setEnabled(false);
            miVista.Opinion.setEnabled(false);
            miVista.Economia.setEnabled(false);
            miVista.Cultura.setEnabled(false);
            miVista.Deportes.setEnabled(false);
            miVista.Eliminar.setEnabled(false);
        }
        if (e.getSource() == miVista.El_Pais) {
            //Si se deselecciona el Checkbox de El País y no queda ningun otro periódico seleccionado
            //se deselecionan los CheckBoxes de tipos de información y se desactivan.
            if(miVista.El_Pais.isSelected()==false){
                if(miVista.ABC.isSelected()==false && miVista.La_Vanguardia.isSelected()==false){
                    miVista.Todos.setEnabled(false);
                    miVista.Eliminar.setEnabled(false);
                    miVista.Ultimo.setEnabled(false);
                    miVista.Opinion.setEnabled(false);
                    miVista.Economia.setEnabled(false);
                    miVista.Cultura.setEnabled(false);
                    miVista.Deportes.setEnabled(false);
                    miVista.Ultimo.setSelected(false);
                    miVista.Opinion.setSelected(false);
                    miVista.Economia.setSelected(false);
                    miVista.Cultura.setSelected(false);
                    miVista.Deportes.setSelected(false);
                }
            }
            //Si se selecciona el Checkbox de El País y se activan los 
            //CheckBoxes de tipos de información.
            else{
                miVista.Todos.setEnabled(true);
                miVista.Eliminar.setEnabled(true);
                miVista.Ultimo.setEnabled(true);
                miVista.Opinion.setEnabled(true);
                miVista.Economia.setEnabled(true);
                miVista.Cultura.setEnabled(true);
                miVista.Deportes.setEnabled(true);
            }
        }
        if (e.getSource() == miVista.ABC) {
            //Si se deselecciona el Checkbox del ABC y no queda ningun otro periódico seleccionado
            //se deselecionan los CheckBoxes de tipos de información y se desactivan.
            if(miVista.ABC.isSelected()==false){
                if(miVista.El_Pais.isSelected()==false && miVista.La_Vanguardia.isSelected()==false){
                    miVista.Todos.setEnabled(false);
                    miVista.Eliminar.setEnabled(false);
                    miVista.Ultimo.setEnabled(false);
                    miVista.Opinion.setEnabled(false);
                    miVista.Economia.setEnabled(false);
                    miVista.Cultura.setEnabled(false);
                    miVista.Deportes.setEnabled(false);
                    miVista.Ultimo.setSelected(false);
                    miVista.Opinion.setSelected(false);
                    miVista.Economia.setSelected(false);
                    miVista.Cultura.setSelected(false);
                    miVista.Deportes.setSelected(false);
                }
            }
            //Si se selecciona el Checkbox del ABC y se activan los 
            //CheckBoxes de tipos de información.
            else{
                miVista.Todos.setEnabled(true);
                miVista.Eliminar.setEnabled(true);
                miVista.Ultimo.setEnabled(true);
                miVista.Opinion.setEnabled(true);
                miVista.Economia.setEnabled(true);
                miVista.Cultura.setEnabled(true);
                miVista.Deportes.setEnabled(true);
            }
        }
        if (e.getSource() == miVista.La_Vanguardia) {
            //Si se deselecciona el Checkbox de La Vanguardia y no queda ningun otro periódico seleccionado
            //se deselecionan los CheckBoxes de tipos de información y se desactivan.
            if(miVista.La_Vanguardia.isSelected()==false){
                if(miVista.El_Pais.isSelected()==false && miVista.ABC.isSelected()==false){
                    miVista.Todos.setEnabled(false);
                    miVista.Eliminar.setEnabled(false);
                    miVista.Ultimo.setEnabled(false);
                    miVista.Opinion.setEnabled(false);
                    miVista.Economia.setEnabled(false);
                    miVista.Cultura.setEnabled(false);
                    miVista.Deportes.setEnabled(false);
                    miVista.Ultimo.setSelected(false);
                    miVista.Opinion.setSelected(false);
                    miVista.Economia.setSelected(false);
                    miVista.Cultura.setSelected(false);
                    miVista.Deportes.setSelected(false);
                }
            }
            //Si se selecciona el Checkbox de La Vanguardia y se activan los 
            //CheckBoxes de tipos de información.
            else{
                miVista.Todos.setEnabled(true);
                miVista.Eliminar.setEnabled(true);
                miVista.Ultimo.setEnabled(true);
                miVista.Opinion.setEnabled(true);
                miVista.Economia.setEnabled(true);
                miVista.Cultura.setEnabled(true);
                miVista.Deportes.setEnabled(true);
            }
        }
        //Cuando el usuario, pulsa el botón de Inicio para comenzar la extracción de titulares.
        if (e.getSource() == miVista.Inicio) {
            //Contador para determinar el número de selecciones que ha marcado.
            int contador=0;
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.El_Pais.isSelected() && miVista.Ultimo.isSelected()){
                period.setNombre_periodico("El Pais");
                period.setTipo_informacion("Último");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.El_Pais.isSelected() && miVista.Opinion.isSelected()){
                period.setNombre_periodico("El Pais");
                period.setTipo_informacion("Opinión");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.El_Pais.isSelected() && miVista.Economia.isSelected()){
                period.setNombre_periodico("El Pais");
                period.setTipo_informacion("Economía");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.El_Pais.isSelected() && miVista.Cultura.isSelected()){
                period.setNombre_periodico("El Pais");
                period.setTipo_informacion("Cultura");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.El_Pais.isSelected() && miVista.Deportes.isSelected()){
                period.setNombre_periodico("El Pais");
                period.setTipo_informacion("Deportes");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.ABC.isSelected() && miVista.Ultimo.isSelected()){
                period.setNombre_periodico("ABC");
                period.setTipo_informacion("Último");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.ABC.isSelected() && miVista.Opinion.isSelected()){
                period.setNombre_periodico("ABC");
                period.setTipo_informacion("Opinión");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
                }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.ABC.isSelected() && miVista.Economia.isSelected()){
                period.setNombre_periodico("ABC");
                period.setTipo_informacion("Economía");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.ABC.isSelected() && miVista.Cultura.isSelected()){
                period.setNombre_periodico("ABC");
                period.setTipo_informacion("Cultura");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.ABC.isSelected() && miVista.Deportes.isSelected()){
                period.setNombre_periodico("ABC");
                period.setTipo_informacion("Deportes");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.La_Vanguardia.isSelected() && miVista.Ultimo.isSelected()){
                period.setNombre_periodico("La Vanguardia");
                period.setTipo_informacion("Último");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.La_Vanguardia.isSelected() && miVista.Opinion.isSelected()){
                period.setNombre_periodico("La Vanguardia");
                period.setTipo_informacion("Opinión");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.La_Vanguardia.isSelected() && miVista.Economia.isSelected()){
                period.setNombre_periodico("La Vanguardia");
                period.setTipo_informacion("Economía");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.La_Vanguardia.isSelected() && miVista.Cultura.isSelected()){
                period.setNombre_periodico("La Vanguardia");
                period.setTipo_informacion("Cultura");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Si se cumple la condición, se actualiza el campo de uso de la BD, indicando
            //que de esta opción seleccionada, se van a tener que extraer los titulares.
            if(miVista.La_Vanguardia.isSelected() && miVista.Deportes.isSelected()){
                period.setNombre_periodico("La Vanguardia");
                period.setTipo_informacion("Deportes");
                period.setUso(true);
                mod.updateUso(period);
                contador++;
            }
            //Se establece la elección del usuario para finaliar el proceso de extracción como nº de horas.
            if(miVista.Horas.isSelected()){
                mod.setElección("Horas");
            }
            //Se establece la elección del usuario para finaliar el proceso de extracción como nº de titulares.
            if(miVista.Titulares.isSelected()){
                mod.setElección("Titulares");
            }
            //Comprobaciones para ver si los datos introducidos por el usuario son correctos.
            //Se comprueba que se ha especificado la opción para finalizar la extracción.
            if(miVista.Horas.isSelected()||miVista.Titulares.isSelected()){
                //Se comprueba que se ha especificado el valor límite, tiene que ser numérico.
                if(!miVista.Valor.getText().equals("") && miVista.Valor.getText().matches("\\d*")){
                    //Se guarda en el modelo el valor introducido.
                    mod.setValor(Integer.parseInt(miVista.Valor.getText()));
                    //Se comprueba que se ha especificado al menos un periódico.
                    if(miVista.El_Pais.isSelected() || miVista.ABC.isSelected() || miVista.La_Vanguardia.isSelected()){
                        //Se comprueba que se ha especificado al menos un tipo de información.
                        //Si toda la información es correcta, se pasa a la vista de Results
                        //iniciando el proceso de extracción.
                        if(contador>0){
                            miVista.dispose();
                            Results frm = new Results();
                            control_Results ctrl = new control_Results(mod,period,frm);
                            mod.setHora_inicio();
                            ctrl.iniciar();
                            frm.setVisible(true);
                            frm.setSize(1100, 700);
                            frm.setResizable(false);
                            Principal.ReadTest.ejecu(ctrl,mod);
                        }
                        //Si no se cumple alguna condición, se muestra el mensaje de error correspondiente.
                        else{
                            JOptionPane.showMessageDialog(null,"Introduce un Tipo de información");
                        }
                    }else{
                        JOptionPane.showMessageDialog(null,"Introduce un Periódico");
                    }                    
                }else{
                    JOptionPane.showMessageDialog(null,"Introduce un valor límite");
                }
            }else{
                JOptionPane.showMessageDialog(null,"Seleccione un límite para le ejecución");        
            }
        }
    }
    /**
     * Al iniciar la ejecución de la herramienta, se actualiza la tabla de Periódico de la
     * base de datos, estableciendo todos los campos a false.
     */
    public void iniciar() {
           miVista.setTitle("Seleccione la información");
           miVista.setLocationRelativeTo(null);
           mod.resetUso();     
    }
}