package Controlador;

import Modelo.Periodico;
import Modelo.UsoBD;
import Vista.Summary;
import Vista.Titulares;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.table.DefaultTableModel;

/**
 * Clase controlador de la vista Titulares.
 * @author Adrián
 */
public class control_Titulares implements ActionListener{

    private UsoBD mod; 
    private Periodico period;
    private Titulares miVista;
    private DefaultTableModel tabla1=null;
    private DefaultTableModel tabla2=null;
    private DefaultTableModel tabla3=null;
 
    /**
     * Método constructor.
     * Se añaden los listener de los objetos de la vista para que muestren los eventos del usuario en la interfaz.
     * @param mod Instancia para interactuar con la base de datos.
     * @param period Instancia para obtener la infromación de los Periódicos.
     * @param miVista Vista Titulares correspondiente.
     */
    public control_Titulares(UsoBD mod,Periodico period,Titulares miVista){       
        this.mod=mod;
        this.period=period;
        this.miVista=miVista;
        this.miVista.Negativos.addActionListener(this);
        this.miVista.Positivos.addActionListener(this);
        this.miVista.Buscados.addActionListener(this);
        this.miVista.Volver.addActionListener(this);
    }
    /**
     * Método llamado al mostrar esta vista. Consulta a la base de datos y guarda los modelos
     * de tabals correspondientes para los titularess positivos, negativos y de búsqueda.
     */
    public void iniciar() {
        tabla1 = mod.getTitulares_Negativos();
        tabla2 = mod.getTitulares_Positivos();
        tabla3 = mod.getTitulares_Buscados();
        miVista.setTitle("Titulares");
        miVista.setLocationRelativeTo(null);
        graficar();
    }
    /**
     * Muestra en la tabla correspondiente los datos que el usuario desea seleccionar.
     */
    public void graficar(){    
        miVista.num_totales.setText(Integer.toString(mod.getUlt()));
        miVista.num_positivos.setText(Integer.toString(tabla2.getRowCount()));
        miVista.num_negativos.setText(Integer.toString(tabla1.getRowCount()));
        miVista.num_busqueda.setText(Integer.toString(tabla3.getRowCount()));
        //Se muestran los titulares negativos.
        if(miVista.Negativos.isSelected()){
            miVista.tblConsultas.setModel(tabla1);
        }
        //Se muestran los titulares positivos.
        if(miVista.Positivos.isSelected()){
            miVista.tblConsultas.setModel(tabla2);
        }
        //Se muestran los titulares de búsqueda.
        if(miVista.Buscados.isSelected()){
            miVista.tblConsultas.setModel(tabla3);
        }
    }
    /**
     * Dependiendo del evento en la vista Titulares se mostrará una información u otra.
     * @param e 
     */
    public void actionPerformed(ActionEvent e) {
        //Se vuelve a la vista anterior de Summary.
        if (e.getSource() == miVista.Volver) {
            finalizar();
        }
        //Se muestra una lista con los titulares considerados negativos.
        if (e.getSource() == miVista.Negativos) {
            graficar();
        }
        //Se muestra una lista con los titulares considerados positivos.
        if (e.getSource() == miVista.Positivos) {
            graficar();
        }
        //Se muestra una lista con los titulares con una palabra de búsqueda.
        if (e.getSource() == miVista.Buscados) {
            graficar();
        }    
    }
    /**
     * Cuando el usuario decide vover a la vista de Summary.
     */
    public void finalizar() {
        miVista.dispose();
        Summary frm = new Summary();
        control_Summary ctrl = new control_Summary(period,mod,frm);
        mod.setHora_inicio();
        ctrl.iniciar();
        frm.setVisible(true);
    }
}