package Principal;

import Modelo.FeedMessage;
import java.util.ArrayList;
import java.util.List;
/**
 * Clase que recibe el link del RSS para leer y almacena en un ArrayList,las
 * instancias de FeedMessage que se corresponden con los titulares y su 
 * información almacenada.
 * @author Adrián
 */
public class Feed {
    //Almacena el URL del RSS.
    String link;
    //Almacena la fecha de actulización del periódico.
    final String pubDate;
    //Lista de instancias de titulares con su información.
    final List<FeedMessage> entries = new ArrayList<FeedMessage>(); 
    /**
    *Método constructor 
    * @param link
    * @param pubDate 
    */
    public Feed(String link, String pubDate) {
        this.link = link;
        this.pubDate = pubDate;
    }
    /**
     * 
     * @return Getter para obtener el ArrayList de titulares
     */
    public List<FeedMessage> getMessages() {
        return entries;
    }
    /**
     * 
     * @return Getter para obtener el link del RSS
     */
    public String getLink() {
        return link;
    }
    /**
     * Setter para establecer el link del RSS
     * @param link 
     */
    public void setLink(String link){
        this.link=link;
    }
    /**
     * 
     * @return Getter para obtener la fecha de actualización del periódico
     */
    public String getPubDate() {
        return pubDate;
    }
}